
sub addDraw{
  local($k, $w, $r, $gk, $or) = @_;

  if ($gk eq ""){ $gk = 1; }
  if ($or eq ""){ $or = 1500; }
  push(@$k, $gk); push(@$w, 0.5); push(@$r, $or);
}


sub rating{
  local($k, $w, $r) = @_;
  local($g, $gh, $gl, $z, $zh, $zl);

  $gh = 5000; $gl = -5000;
  while(($gh-$gl)>1){
    $g = int(($gh+$gl)/2);
    $z = sumkwr($g, $k, $w, $r);
# uncomment the following line to debug
#print "$gl $gh  $g $z\n";
    if ($z <= 0){ $gh = $g; $zh = $z; }
    if ($z >= 0){ $gl = $g; $zl = $z; }
  }
  $g = $gl;
  if (abs($zh)<$zl){ $g = $gh; }
  return $g;
}



sub sumkwr{
  local($mr, $k, $w, $or) = @_;
  local(@k, @w, @or);
  local($i, $j, $s);

  @k = @$k;
  @w = @$w;
  @or = @$or;

  $i = 0;
  foreach $j (@or){
    $s += kwr($k[$i], $w[$i], $mr, $or[$i]);
    $i++;
  }
  return $s;
}


sub kwr{
  local($k, $w, $mr, $or) = @_;
  local($a);

  $a = $k*($w - wp($mr, $or));
  return $a;
}


sub wp{
  local($mr, $or) = @_;
  local($rd, $wp);

  $rd = ($or - $mr)/400.0;
  $wp = 1.0/(1.0 + 10**$rd);

  return $wp;
}

sub totalWeight{
  local($w) = @_;
  local(@w, $t);

  @w = @$w;
  foreach (@w){ $t += $_; }
  $t = sprintf("%.1f", $t);
  return $t;
}

sub effOpp{
  local($k, $r) = @_;
  local(@k, @r);
  local($i, $tkr, $tk, $mr);

  @k = @$k;
  @r = @$r;
  $i = 0;
  foreach (@k){
    $tkr += $k[$i]*$r[$i];
    $tk += $k[$i];
  }
  $mr = $tkr/$tk;
  $mr = sprintf("%.0f", $mr);
  return $mr;
}

sub addLose{
  local($k, $w, $r, $gk, $or) = @_;

  if ($gk eq ""){ $gk = 1; }
  if ($or eq ""){ $or = 1500; }
  push(@$k, $gk); push(@$w, 0); push(@$r, $or);
}

sub addWin{
  local($k, $w, $r, $gk, $or) = @_;

  if ($gk eq ""){ $gk = 1; }
  if ($or eq ""){ $or = 1500; }
  push(@$k, $gk); push(@$w, 1); push(@$r, $or);
}

sub addGame{
  local($k, $w, $r, $u, $t, $gi) = @_;
  local($mk, $mw, $mr, $mu, $mt);

  ($mk, $mw, $mr, $mu, $mt) = ($gi =~ m/^(-?[\d\.]*) *(-?[\d\.]*) *(-?\d+) *(\w*) *(\d*)/);
  if ($mk eq ""){ $mk = 1; }
  if ($mw eq ""){ die "addGame cant process $gi\n"; }
  if ($mr eq ""){ die "addGame cant process $gi\n"; }
  if ($mu eq ""){ $mu = "unknown"; }
  if ($mt eq ""){ $mt = 0; }
  $mk += 0.0;
  $mw += 0.0;
  unshift(@$k, $mk); unshift(@$w, $mw); unshift(@$r, $mr);unshift(@$u, $mu);unshift(@$t, $mt);
}

1;

